/**
 * @file passing_arguments.cpp
 * @author Fabian Kantereit
 *
 * This file covers the passing of arguments to threads
 */

#include <iostream>
#include <thread>

void add_result(int i, int j, int &result) { result = i + j; }

int main(int argc, char *argv[]) {
  // we can pass function arguments as additional parameters
  int i = 3;
  int j = 5;

  /************************************
   * passing arguments as parameters
   ************************************/

  std::thread t1([](int i, int j) { std::cout << i + j << std::endl; }, i, j);

  int result = 0;

  /***********************************
   * passing references
   ***********************************/
  std::thread t2(add_result, i, j, std::ref(result));

  t1.join();
  t2.join();

  std::cout << "result of " << i << "+" << j << " is " << result << std::endl;

  return 0;
}
