/**
 * @file threadsynchro.cpp
 * @author Fabian Kantereit
 */

#include <iostream>
#include <mutex>
#include <thread>
#include <chrono>

const int limited = 10000000;

void unsafe_modify_variable(int& var, int difference) {
  for(int i = 0; i < limited ; ++i) {
    var += difference;
  }
}

std::mutex m;

/**
 * simple stupid example for demonstration mutexes
 */
void use_mutex(int& var, int difference) {
  for(int i = 0; i < limited; ++i){
    m.lock();
    var += difference;
    m.unlock();
  }
}

int main(int argc, char *argv[])
{
  int var = 0;
  std::thread t1(unsafe_modify_variable, std::ref(var), 1);
  std::thread t2(unsafe_modify_variable, std::ref(var), -1);

  t1.join();
  t2.join();

  std::cout << "Value of var: " << var << std::endl;

  int var2 = 0;
  std::thread t3(use_mutex, std::ref(var2), 1);
  std::thread t4(use_mutex, std::ref(var2), -1);

  t3.join();
  t4.join();

  std::cout << "Value of var2: " << var2 << std::endl;


  return 0;
}
