/**
 * @file mutex_exception.cpp
 * @author Fabian Kantereit
 */

#include <iostream>
#include <thread>
#include <mutex>

std::mutex m_cout;

void safe_cout(const char* message) {
  try {
    m_cout.lock();
    std::cout << message << std::endl;

    static int count = 0;
    ++count;
    // provoke deadlock
    if(count == 1) {
      throw 0;
    }
    m_cout.unlock();
  } catch (...) {

  }
}

int main(int argc, char *argv[])
{
  std::thread t1(safe_cout, "Hello ");
  std::thread t2(safe_cout, "World ");
  std::thread t3(safe_cout, "Today");
  std::thread t4(safe_cout, "is a good day");

  t1.join();
  t2.join();
  t3.join();
  t4.join();
  return 0;
}
